/*******************************************************************************
 * McpUserManager generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class McpUserManager extends McpUserManagerBase
    config(Engine);

struct UserRequest
{
    var string McpId;
    var HttpRequestInterface Request;

    structdefaultproperties
    {
        McpId=""
        Request=none
    }
};

var array<McpUserStatus> UserStatuses;
var config string RegisterUserMcpUrl;
var config string RegisterUserFacebookUrl;
var config string QueryUserUrl;
var config string QueryUsersUrl;
var config string DeleteUserUrl;
var config string FacebookAuthUrl;
var config string McpAuthUrl;
var array<HttpRequestInterface> RegisterUserRequests;
var array<HttpRequestInterface> QueryUsersRequests;
var array<UserRequest> DeleteUserRequests;
var array<HttpRequestInterface> AuthUserRequests;

function RegisterUserGenerated()
{
    local string URL;
    local HttpRequestInterface Request;
    local int AddAt;

    Request = class'HttpFactory'.static.CreateRequest();
    // End:0x14C
    if(Request != none)
    {
        URL = ((GetBaseURL()) $ RegisterUserMcpUrl) $ (GetAppAccessURL());
        Request.SetURL(URL);
        Request.SetVerb("POST");
        Request.__OnProcessRequestComplete__Delegate = OnRegisterUserRequestComplete;
        AddAt = RegisterUserRequests.Length;
        RegisterUserRequests.Length = AddAt + 1;
        RegisterUserRequests[AddAt] = Request;
        // End:0x14C
        if(!Request.ProcessRequest())
        {
        }
    }
    //return;    
}

function RegisterUserFacebook(string FacebookId, string FacebookAuthToken)
{
    local string URL;
    local HttpRequestInterface Request;
    local int AddAt;

    Request = class'HttpFactory'.static.CreateRequest();
    // End:0x185
    if(Request != none)
    {
        URL = ((((((GetBaseURL()) $ RegisterUserFacebookUrl) $ (GetAppAccessURL())) $ "&facebookId=") $ FacebookId) $ "&facebookToken=") $ FacebookAuthToken;
        Request.SetURL(URL);
        Request.SetVerb("POST");
        Request.__OnProcessRequestComplete__Delegate = OnRegisterUserRequestComplete;
        AddAt = RegisterUserRequests.Length;
        RegisterUserRequests.Length = AddAt + 1;
        RegisterUserRequests[AddAt] = Request;
        // End:0x185
        if(!Request.ProcessRequest())
        {
        }
    }
    //return;    
}

protected function int ParseUser(string JsonPayload)
{
    local JsonObject ParsedJson;
    local int UserIndex;
    local string McpId;

    ParsedJson = class'JsonObject'.static.DecodeJson(JsonPayload);
    // End:0x3FF
    if(ParsedJson.HasKey("unique_user_id"))
    {
        McpId = ParsedJson.GetStringValue("unique_user_id");
        UserIndex = UserStatuses.Find('McpId', McpId);
        // End:0x134
        if(UserIndex == -1)
        {
            UserIndex = UserStatuses.Length;
            UserStatuses.Length = UserIndex + 1;
            UserStatuses[UserIndex].McpId = McpId;
        }
        // End:0x1BA
        if(ParsedJson.HasKey("client_secret"))
        {
            UserStatuses[UserIndex].SecretKey = ParsedJson.GetStringValue("client_secret");
        }
        // End:0x232
        if(ParsedJson.HasKey("ticket"))
        {
            UserStatuses[UserIndex].Ticket = ParsedJson.GetStringValue("ticket");
        }
        // End:0x2A6
        if(ParsedJson.HasKey("udid"))
        {
            UserStatuses[UserIndex].UDID = ParsedJson.GetStringValue("udid");
        }
        UserStatuses[UserIndex].RegisteredDate = ParsedJson.GetStringValue("registered_date");
        UserStatuses[UserIndex].LastActiveDate = ParsedJson.GetStringValue("last_active_date");
        UserStatuses[UserIndex].DaysInactive = ParsedJson.GetIntValue("days_inactive");
        UserStatuses[UserIndex].bIsBanned = ParsedJson.GetBoolValue("is_banned");
    }
    // End:0x40E
    else
    {
        UserIndex = -1;
    }
    return UserIndex;
    //return ReturnValue;    
}

function OnRegisterUserRequestComplete(HttpRequestInterface Request, HttpResponseInterface Response, bool bWasSuccessful)
{
    local int Index, ResponseCode, UserIndex;
    local string ResponseString, McpId;

    Index = RegisterUserRequests.Find(Request);
    // End:0x198
    if(Index != -1)
    {
        ResponseCode = 500;
        // End:0x7A
        if(Response != none)
        {
            ResponseCode = Response.GetResponseCode();
        }
        ResponseString = Response.GetContentAsString();
        bWasSuccessful = bWasSuccessful && ResponseCode == 200;
        // End:0x113
        if(bWasSuccessful)
        {
            UserIndex = ParseUser(ResponseString);
            // End:0x113
            if(UserIndex == -1)
            {
                bWasSuccessful = false;
            }
        }
        McpId = ((bWasSuccessful) ? UserStatuses[UserIndex].McpId : "");
        OnRegisterUserComplete(McpId, bWasSuccessful, ResponseString);
        RegisterUserRequests.Remove(Index, 1);
    }
    //return;    
}

function AuthenticateUserFacebook(string FacebookId, string FacebookToken, string UDID)
{
    local string URL;
    local HttpRequestInterface Request;
    local int AddAt;

    Request = class'HttpFactory'.static.CreateRequest();
    // End:0x19A
    if(Request != none)
    {
        URL = ((((((((GetBaseURL()) $ FacebookAuthUrl) $ (GetAppAccessURL())) $ "&facebookId=") $ FacebookId) $ "&facebookToken=") $ FacebookToken) $ "&udid=") $ UDID;
        Request.SetURL(URL);
        Request.SetVerb("POST");
        Request.__OnProcessRequestComplete__Delegate = OnAuthenticateUserRequestComplete;
        AddAt = AuthUserRequests.Length;
        AuthUserRequests.Length = AddAt + 1;
        AuthUserRequests[AddAt] = Request;
        // End:0x19A
        if(!Request.ProcessRequest())
        {
        }
    }
    //return;    
}

function AuthenticateUserMcp(string McpId, string ClientSecret, string UDID)
{
    local string URL;
    local HttpRequestInterface Request;
    local int AddAt;

    Request = class'HttpFactory'.static.CreateRequest();
    // End:0x19B
    if(Request != none)
    {
        URL = ((((((((GetBaseURL()) $ McpAuthUrl) $ (GetAppAccessURL())) $ "&uniqueUserId=") $ McpId) $ "&clientSecret=") $ ClientSecret) $ "&udid=") $ UDID;
        Request.SetURL(URL);
        Request.SetVerb("POST");
        Request.__OnProcessRequestComplete__Delegate = OnAuthenticateUserRequestComplete;
        AddAt = AuthUserRequests.Length;
        AuthUserRequests.Length = AddAt + 1;
        AuthUserRequests[AddAt] = Request;
        // End:0x19B
        if(!Request.ProcessRequest())
        {
        }
    }
    //return;    
}

function OnAuthenticateUserRequestComplete(HttpRequestInterface Request, HttpResponseInterface Response, bool bWasSuccessful)
{
    local int Index, ResponseCode, UserIndex;
    local string ResponseString, McpId, Ticket;

    Index = AuthUserRequests.Find(Request);
    // End:0x1CD
    if(Index != -1)
    {
        ResponseCode = 500;
        // End:0x7A
        if(Response != none)
        {
            ResponseCode = Response.GetResponseCode();
        }
        ResponseString = Response.GetContentAsString();
        bWasSuccessful = bWasSuccessful && ResponseCode == 200;
        // End:0x113
        if(bWasSuccessful)
        {
            UserIndex = ParseUser(ResponseString);
            // End:0x113
            if(UserIndex == -1)
            {
                bWasSuccessful = false;
            }
        }
        // End:0x180
        if(bWasSuccessful)
        {
            McpId = UserStatuses[UserIndex].McpId;
            Ticket = UserStatuses[UserIndex].Ticket;
        }
        OnAuthenticateUserComplete(McpId, Ticket, bWasSuccessful, ResponseString);
        AuthUserRequests.Remove(Index, 1);
    }
    //return;    
}

function QueryUser(string McpId, optional bool bShouldUpdateLastActive)
{
    local string URL;
    local HttpRequestInterface Request;
    local int AddAt;

    Request = class'HttpFactory'.static.CreateRequest();
    // End:0x19F
    if((Request != none) && McpId != "")
    {
        URL = ((((((GetBaseURL()) $ QueryUserUrl) $ (GetAppAccessURL())) $ "&uniqueUserId=") $ McpId) $ "&updateLastActive=") $ string(bShouldUpdateLastActive);
        Request.SetURL(URL);
        Request.SetVerb("GET");
        Request.__OnProcessRequestComplete__Delegate = OnQueryUserRequestComplete;
        AddAt = QueryUsersRequests.Length;
        QueryUsersRequests.Length = AddAt + 1;
        QueryUsersRequests[AddAt] = Request;
        // End:0x19F
        if(!Request.ProcessRequest())
        {
        }
    }
    //return;    
}

function OnQueryUserRequestComplete(HttpRequestInterface Request, HttpResponseInterface Response, bool bWasSuccessful)
{
    local int Index, ResponseCode, UserIndex;
    local string ResponseString;

    Index = QueryUsersRequests.Find(Request);
    // End:0x14E
    if(Index != -1)
    {
        ResponseCode = 500;
        // End:0x7A
        if(Response != none)
        {
            ResponseCode = Response.GetResponseCode();
        }
        ResponseString = Response.GetContentAsString();
        bWasSuccessful = bWasSuccessful && ResponseCode == 200;
        // End:0x113
        if(bWasSuccessful)
        {
            UserIndex = ParseUser(ResponseString);
            // End:0x113
            if(UserIndex == -1)
            {
                bWasSuccessful = false;
            }
        }
        OnQueryUsersComplete(bWasSuccessful, ResponseString);
        QueryUsersRequests.Remove(Index, 1);
    }
    //return;    
}

function QueryUsers(const out array<string> McpIds)
{
    local string URL;
    local HttpRequestInterface Request;
    local int AddAt;
    local string JsonPayload;
    local int Index;

    Request = class'HttpFactory'.static.CreateRequest();
    // End:0x273
    if(Request != none)
    {
        URL = ((GetBaseURL()) $ QueryUsersUrl) $ (GetAppAccessURL());
        JsonPayload = "[ ";
        Index = 0;
        J0x7C:
        // End:0x107 [Loop If]
        if(Index < McpIds.Length)
        {
            JsonPayload $= (("\\"" $ McpIds[Index]) $ "\\"");
            // End:0xF9
            if((Index + 1) < McpIds.Length)
            {
                JsonPayload $= ",";
            }
            ++ Index;
            // [Loop Continue]
            goto J0x7C;
        }
        JsonPayload $= " ]";
        Request.SetURL(URL);
        Request.SetContentAsString(JsonPayload);
        Request.SetVerb("POST");
        Request.SetHeader("Content-Type", "multipart/form-data");
        Request.__OnProcessRequestComplete__Delegate = OnQueryUsersRequestComplete;
        AddAt = QueryUsersRequests.Length;
        QueryUsersRequests.Length = AddAt + 1;
        QueryUsersRequests[AddAt] = Request;
        // End:0x273
        if(!Request.ProcessRequest())
        {
        }
    }
    //return;    
}

protected function ParseUsers(string JsonPayload)
{
    local JsonObject ParsedJson;
    local int JsonIndex, UserIndex;
    local string McpId;

    ParsedJson = class'JsonObject'.static.DecodeJson(JsonPayload);
    JsonIndex = 0;
    J0x3D:
    // End:0x442 [Loop If]
    if(JsonIndex < ParsedJson.ObjectArray.Length)
    {
        // End:0x434
        if(ParsedJson.HasKey("unique_user_id"))
        {
            McpId = ParsedJson.GetStringValue("unique_user_id");
            UserIndex = UserStatuses.Find('McpId', McpId);
            // End:0x16C
            if(UserIndex == -1)
            {
                UserIndex = UserStatuses.Length;
                UserStatuses.Length = UserIndex + 1;
                UserStatuses[UserIndex].McpId = McpId;
            }
            // End:0x1F2
            if(ParsedJson.HasKey("client_secret"))
            {
                UserStatuses[UserIndex].SecretKey = ParsedJson.GetStringValue("client_secret");
            }
            // End:0x26A
            if(ParsedJson.HasKey("ticket"))
            {
                UserStatuses[UserIndex].Ticket = ParsedJson.GetStringValue("ticket");
            }
            // End:0x2DE
            if(ParsedJson.HasKey("udid"))
            {
                UserStatuses[UserIndex].UDID = ParsedJson.GetStringValue("udid");
            }
            UserStatuses[UserIndex].RegisteredDate = ParsedJson.GetStringValue("registered_date");
            UserStatuses[UserIndex].LastActiveDate = ParsedJson.GetStringValue("last_active_date");
            UserStatuses[UserIndex].DaysInactive = ParsedJson.GetIntValue("days_inactive");
            UserStatuses[UserIndex].bIsBanned = ParsedJson.GetBoolValue("is_banned");
        }
        ++ JsonIndex;
        // [Loop Continue]
        goto J0x3D;
    }
    //return;    
}

function OnQueryUsersRequestComplete(HttpRequestInterface Request, HttpResponseInterface Response, bool bWasSuccessful)
{
    local int Index, ResponseCode;
    local string ResponseString;

    Index = QueryUsersRequests.Find(Request);
    // End:0x125
    if(Index != -1)
    {
        ResponseCode = 500;
        // End:0x7A
        if(Response != none)
        {
            ResponseCode = Response.GetResponseCode();
        }
        ResponseString = Response.GetContentAsString();
        bWasSuccessful = bWasSuccessful && ResponseCode == 200;
        // End:0xEA
        if(bWasSuccessful)
        {
            ParseUsers(ResponseString);
        }
        OnQueryUsersComplete(bWasSuccessful, ResponseString);
        QueryUsersRequests.Remove(Index, 1);
    }
    //return;    
}

function GetUsers(out array<McpUserStatus> Users)
{
    Users = UserStatuses;
    //return;    
}

function bool GetUser(string McpId, out McpUserStatus User)
{
    local int UserIndex;

    UserIndex = UserStatuses.Find('McpId', McpId);
    // End:0x5B
    if(UserIndex != -1)
    {
        User = UserStatuses[UserIndex];
        return true;
    }
    return false;
    //return ReturnValue;    
}

function DeleteUser(string McpId)
{
    local string URL;
    local HttpRequestInterface Request;
    local int AddAt;

    Request = class'HttpFactory'.static.CreateRequest();
    // End:0x1AE
    if(Request != none)
    {
        URL = ((((GetBaseURL()) $ DeleteUserUrl) $ (GetAppAccessURL())) $ "&uniqueUserId=") $ McpId;
        Request.SetURL(URL);
        Request.SetVerb("DELETE");
        Request.__OnProcessRequestComplete__Delegate = OnDeleteUserRequestComplete;
        AddAt = DeleteUserRequests.Length;
        DeleteUserRequests.Length = AddAt + 1;
        DeleteUserRequests[AddAt].McpId = McpId;
        DeleteUserRequests[AddAt].Request = Request;
        // End:0x1AE
        if(!Request.ProcessRequest())
        {
        }
    }
    //return;    
}

function OnDeleteUserRequestComplete(HttpRequestInterface Request, HttpResponseInterface Response, bool bWasSuccessful)
{
    local int Index, UserIndex, ResponseCode;

    Index = DeleteUserRequests.Find('Request', Request);
    // End:0x176
    if(Index != -1)
    {
        ResponseCode = 500;
        // End:0x83
        if(Response != none)
        {
            ResponseCode = Response.GetResponseCode();
        }
        bWasSuccessful = bWasSuccessful && ResponseCode == 200;
        // End:0x125
        if(bWasSuccessful)
        {
            UserIndex = UserStatuses.Find('McpId', DeleteUserRequests[Index].McpId);
            // End:0x125
            if(UserIndex != -1)
            {
                UserStatuses.Remove(UserIndex, 1);
            }
        }
        OnDeleteUserComplete(bWasSuccessful, Response.GetContentAsString());
        DeleteUserRequests.Remove(Index, 1);
    }
    //return;    
}

defaultproperties
{
    RegisterUserMcpUrl="/registerusermcp"
    RegisterUserFacebookUrl="/registeruserfacebook"
    QueryUserUrl="/userstatus"
    QueryUsersUrl="/usermultiplestatus"
    DeleteUserUrl="/deleteuser"
    FacebookAuthUrl="/authenticateuserfacebook"
    McpAuthUrl="/authenticateusermcp"
}